/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseDataSource } from "./BaseDataSource";
import { Base, typeCast, Array_$type, Number_$type, markType } from "./type";
import { RearrangedListView } from "./RearrangedListView";
import { DataSourcePropertiesComparer } from "./DataSourcePropertiesComparer";
import { List$1 } from "./List$1";
import { DataSourceExecutionContext } from "./DataSourceExecutionContext";
import { DataSourceLocalDataProvider } from "./DataSourceLocalDataProvider";
import { DataSourceSpecialRow } from "./DataSourceSpecialRow";
import { ISupportsDataChangeNotifications_$type } from "./ISupportsDataChangeNotifications";
import { ISupportsExpansionChangeNotifications_$type } from "./ISupportsExpansionChangeNotifications";
/**
 * @hidden
 */
export let LocalDataSource = /*@__PURE__*/ (() => {
    class LocalDataSource extends BaseDataSource {
        constructor() {
            super();
            this.cg = null;
            this.cf = null;
            this.df = null;
            this.cl = null;
            this.cp = null;
            this.cr = null;
            this.cn = null;
            this.c1 = new List$1(Array_$type, 0);
            this.cs = false;
            this.ce = null;
            this.c9 = -1;
            this.c2 = -1;
            this.db = -1;
            this.c4 = -1;
            this.dc = -1;
            this.c5 = -1;
            this.da = -1;
            this.c3 = -1;
            this.de = -1;
            this.dd = -1;
            this.c7 = -1;
            this.c6 = -1;
            this.c8 = -1;
            this.executionContext = new DataSourceExecutionContext();
        }
        get_actualBaseDataProvider() {
            return this.actualDataProvider;
        }
        get actualBaseDataProvider() {
            return this.get_actualBaseDataProvider();
        }
        get dataProvider() {
            return this.cg;
        }
        set dataProvider(a) {
            let b = this.cg;
            this.cg = a;
            if (b != this.cg) {
                this.onPropertyUpdated("DataProvider", b, this.cg);
            }
        }
        get actualDataProvider() {
            if (this.cf == null) {
                this.actualDataProvider = this.resolveDataProvider();
            }
            return this.cf;
        }
        set actualDataProvider(a) {
            let b = this.cf;
            this.cf = a;
            if (b != this.cf) {
                this.onPropertyUpdated("ActualDataProvider", b, this.cf);
            }
        }
        get itemsSource() {
            return this.df;
        }
        set itemsSource(a) {
            let b = this.df;
            this.df = a;
            if (b != this.df) {
                this.onPropertyUpdated("ItemsSource", b, this.df);
            }
        }
        canInitialize() {
            let a = super.canInitialize();
            if (!a) {
                return false;
            }
            return this.itemsSource != null;
        }
        get cm() {
            return this.cl;
        }
        set cm(a) {
            this.cl = a;
            this.actualDataProvider = this.resolveDataProvider();
        }
        resolveDataProvider() {
            let provider_ = new DataSourceLocalDataProvider();
            provider_.executionContext = new DataSourceExecutionContext();
            return provider_;
        }
        propertyUpdatedOverride(a, b, c) {
            super.propertyUpdatedOverride(a, b, c);
            switch (a) {
                case "DataProvider":
                    this.actualDataProvider = this.dataProvider;
                    break;
                case "ActualDataProvider":
                    if (this.actualDataProvider != null) {
                        this.actualDataProvider.dataSource = this.itemsSource;
                        this.actualSchema = this.actualDataProvider.actualSchema;
                        this.actualCount = this.resolveFullCount(this.actualDataProvider.actualCount);
                    }
                    this.queueAutoRefresh();
                    break;
                case "ItemsSource":
                    if (this.actualDataProvider != null) {
                        this.actualDataProvider.dataSource = this.itemsSource;
                        this.actualSchema = this.actualDataProvider.actualSchema;
                        this.actualCount = this.resolveFullCount(this.actualDataProvider.actualCount);
                    }
                    this.queueAutoRefresh();
                    break;
            }
        }
        getItemAtIndex(a) {
            if (this.cp != null && this.cp.a6 != null) {
                return this.cp.a6.item(a);
            }
            else {
                return this.actualDataProvider.getItemAtIndex(a);
            }
        }
        getItemPropertyAtIndex(a, b) {
            let c;
            if (this.cp != null) {
                c = this.cp.a6.item(a);
            }
            else {
                c = this.actualDataProvider.getItemAtIndex(a);
            }
            let item_ = c;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                return this.getSpecialRowItemValue(c, b);
            }
            return this.actualDataProvider.getItemValue(c, b);
        }
        ck() {
            return this.actualDataProvider;
        }
        cu() {
            return this.c1 != null && this.c1.count > 0;
        }
        refreshInternalOverride() {
            super.refreshInternalOverride();
            if (this.actualDataProvider != null) {
                if (this.cv() || this.cw() || this.cx() || this.cy() || this.cu()) {
                    if (this.cp == null) {
                        if (this.cr == null) {
                            this.cr = new LocalDataSourceViewUpdateNotifier(this);
                        }
                        this.cp = new RearrangedListView(this.actualDataProvider);
                        this.cp.ab = this.cr;
                        this.cp.ad = new LocalDataSourceViewExpansionNotifier(this);
                    }
                    this.ensureComparables(this.actualDataProvider.actualSchema);
                    this.cp.av = this.shouldEmitSectionHeaders && this.aj;
                    this.cp.au = this.shouldEmitSectionFooters && this.aj;
                    this.cp.aw = this.shouldEmitShiftedRows;
                    this.cp.cb(this.c1);
                    this.cp.a2 = this.c0();
                    this.cp.a1 = this.cz();
                    this.cp.p = this.co();
                    this.cp.ae = this.groupDescriptions;
                    this.cp.af = this.sortDescriptions;
                    this.cp.ag = this.summaryDescriptions;
                    this.cp.l = this.summaryScope;
                    this.cp.am = this.includeSummaryRowsInSection;
                    this.cp.as = this.isSectionSummaryRowsAtBottom;
                    this.cp.j = this.sectionHeaderDisplayMode;
                    this.cp.m = this;
                    this.cp.ap = this.groupDescriptions != null && this.groupDescriptions.k.count > 0;
                    this.cp.t = this.cq();
                    this.cp.b6();
                    this.actualSchema = this.actualDataProvider.actualSchema;
                    this.actualCount = this.cp.a6.count;
                }
                else {
                    let a = this.ck();
                    this.actualSchema = this.actualDataProvider.actualSchema;
                    if (a != null) {
                        this.actualCount = a.actualCount;
                    }
                    else {
                        this.actualCount = 0;
                    }
                    if (this.cp != null) {
                        this.cp.ab = null;
                        this.cp = null;
                        this.onBroadcastClearItems();
                    }
                }
            }
            else {
                this.actualCount = 0;
                this.actualSchema = null;
            }
        }
        get_isItemIndexLookupSupported() {
            return true;
        }
        get_isKeyIndexLookupSupported() {
            return true;
        }
        indexOfItem(a) {
            if (this.cp != null) {
                return this.cp.a6.indexOf(a);
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isItemIndexLookupSupported) {
                return this.actualDataProvider.indexOfItem(a);
            }
            if (this.actualDataProvider != null) {
                let b = this.actualDataProvider.actualCount;
                let c;
                for (let d = 0; d < b; d++) {
                    c = this.actualDataProvider.getItemAtIndex(d);
                    if (this.ct(c, a)) {
                        return d;
                    }
                }
            }
            return -1;
        }
        ct(a, b) {
            if (a == null && b == null) {
                return true;
            }
            if (a == null || b == null) {
                return false;
            }
            return Base.equalsStatic(a, b);
        }
        indexOfKey(a) {
            let b = this.actualPrimaryKey;
            if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
                return this.indexOfItem(a[0]);
            }
            let c = this.co();
            let d;
            if (this.cp != null) {
                let e = this.cp.a6.count;
                for (let f = 0; f < e; f++) {
                    d = this.cp.a6.item(f);
                    if (typeCast(DataSourceSpecialRow.$, d) !== null) {
                        let g = d;
                        if (g.rowType == 1 && !this.isSectionContentVisible && this.isSectionHeaderNormalRow) {
                            if (c.i(d, a) == 0) {
                                return f;
                            }
                        }
                    }
                    else if (c.i(d, a) == 0) {
                        return f;
                    }
                }
                return -1;
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
                return this.actualDataProvider.indexOfKey(a);
            }
            if (this.actualDataProvider != null) {
                let h = this.actualDataProvider.actualCount;
                for (let i = 0; i < h; i++) {
                    d = this.actualDataProvider.getItemAtIndex(i);
                    if (c.i(d, a) == 0) {
                        return i;
                    }
                }
            }
            return -1;
        }
        onActualPrimaryKeyChangedOverrride(a, b) {
            super.onActualPrimaryKeyChangedOverrride(a, b);
            this.cn = null;
        }
        co() {
            if (this.cn != null) {
                return this.cn;
            }
            if (this.actualPrimaryKey == null) {
                this.cn = new DataSourcePropertiesComparer(null, null, null, this);
                return this.cn;
            }
            let a = new Array(this.actualPrimaryKey.length);
            for (let b = 0; b < a.length; b++) {
                a[b] = 0;
            }
            this.cn = new DataSourcePropertiesComparer(this.actualPrimaryKey, a, this.d, this);
            return this.cn;
        }
        cq() {
            if (this.filterExpressions.j.count == 0) {
                return null;
            }
            let a = this.actualDataProvider;
            let b = this.actualDataProvider.actualSchema;
            let c = this.filterExpressions.j;
            let d = (e) => {
                for (let f = 0; f < c.count; f++) {
                    if (!c.item(f).match(e, a, b)) {
                        return false;
                    }
                }
                return true;
            };
            return d;
        }
        c0() {
            let a = 0;
            if (this.sortDescriptions.k.count == 0 && (this.groupDescriptions == null || this.groupDescriptions.k.count == 0)) {
                return null;
            }
            a = this.sortDescriptions.k.count;
            if (this.groupDescriptions != null) {
                a += this.groupDescriptions.k.count;
            }
            let b = new Array(a);
            let c = new Array(a);
            let d = 0;
            if (this.groupDescriptions != null) {
                for (let e = 0; e < this.groupDescriptions.k.count; e++) {
                    b[e] = this.groupDescriptions.k.item(e).propertyName;
                    c[e] = this.groupDescriptions.k.item(e).direction;
                    d++;
                }
            }
            for (let f = 0; f < this.sortDescriptions.k.count; f++) {
                b[f + d] = this.sortDescriptions.k.item(f).propertyName;
                c[f + d] = this.sortDescriptions.k.item(f).direction;
            }
            return new DataSourcePropertiesComparer(b, c, this.d, this);
        }
        cz() {
            if (this.groupDescriptions == null || this.groupDescriptions.k.count < 1) {
                return null;
            }
            let a = 0;
            a = this.groupDescriptions.k.count;
            let b = new Array(a);
            let c = new Array(a);
            if (this.groupDescriptions != null) {
                for (let d = 0; d < this.groupDescriptions.k.count; d++) {
                    b[d] = this.groupDescriptions.k.item(d).propertyName;
                    c[d] = this.groupDescriptions.k.item(d).direction;
                }
            }
            return new DataSourcePropertiesComparer(b, c, this.d, this);
        }
        cw() {
            if (this.groupDescriptions == null || this.groupDescriptions.k.count < 1) {
                return false;
            }
            if (this.actualDataProvider == null) {
                return false;
            }
            if (this.actualDataProvider.isGroupingSupported) {
                return false;
            }
            return true;
        }
        cx() {
            if (this.sortDescriptions == null || this.sortDescriptions.k.count < 1) {
                return false;
            }
            if (this.actualDataProvider == null) {
                return false;
            }
            if (this.actualDataProvider.isSortingSupported) {
                return false;
            }
            return true;
        }
        cv() {
            return this.filterExpressions != null && this.filterExpressions.j.count > 0;
        }
        cy() {
            if (this.summaryDescriptions == null || this.summaryDescriptions.k.count < 1) {
                return false;
            }
            return true;
        }
        onClearItemsOverride() {
            if (this.cp != null) {
                this.cp.notifyClearItems();
                this.queueAutoRefresh();
            }
            else {
                super.onClearItemsOverride();
            }
        }
        onSetItemOverride(a, b, c) {
            if (this.cp != null) {
                this.cp.notifySetItem(a, b, c);
            }
            else {
                super.onSetItemOverride(a, b, c);
            }
        }
        onInsertItemOverride(a, b) {
            if (this.cp != null) {
                this.cp.notifyInsertItem(a, b);
            }
            else {
                super.onInsertItemOverride(a, b);
            }
        }
        onRemoveItemOverride(a, b) {
            if (this.cp != null) {
                this.cp.notifyRemoveItem(a, b);
            }
            else {
                super.onRemoveItemOverride(a, b);
            }
        }
        dk() {
            this.actualCount = this.cp.a6.count;
            this.onBroadcastClearItems();
        }
        dn(a, b, c) {
            this.actualCount = this.cp.a6.count;
            this.onBroadcastSetItem(a, b, c);
        }
        dl(a, b) {
            this.actualCount = this.cp.a6.count;
            this.onBroadcastInsertItem(a, b);
        }
        dm(a, b) {
            this.actualCount = this.cp.a6.count;
            this.onBroadcastRemoveItem(a, b);
        }
        pinRow(a) {
            super.pinRow(a);
            this.c9 = -1;
            this.c2 = -1;
            if (this.cp != null) {
                this.c1.add(a);
                this.cp.b5(a);
            }
            else {
                this.c1.add(a);
                this.queueAutoRefresh();
            }
        }
        unpinRow(a) {
            super.unpinRow(a);
            let b = this.co();
            if (this.cp != null) {
                for (let c = this.c1.count - 1; c >= 0; c--) {
                    let d = this.c1._inner[c];
                    if (d.length != a.length) {
                        continue;
                    }
                    if (b.h(d, a) == 0) {
                        this.c1.removeAt(c);
                        this.cp.cc(d);
                    }
                }
            }
            else {
                for (let e = this.c1.count - 1; e >= 0; e--) {
                    let f = this.c1._inner[e];
                    if (f.length != a.length) {
                        continue;
                    }
                    if (b.h(f, a) == 0) {
                        this.c1.removeAt(e);
                    }
                }
                this.queueAutoRefresh();
            }
            this.c9 = -1;
            this.c2 = -1;
        }
        clearPinnedRows() {
            for (let a = this.c1.count - 1; a >= 0; a--) {
                this.unpinRow(this.c1._inner[a]);
            }
        }
        isRowPinned(a) {
            if (this.cp == null) {
                return false;
            }
            let b = this.getItemAtIndex(a);
            if (b == null) {
                return false;
            }
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                if (item_.rowType == 3) {
                    return true;
                }
            }
            let c = this.co();
            let d;
            if (this.actualPrimaryKey == null) {
                d = new Array(1);
                d[0] = b;
            }
            else {
                let e = this.actualPrimaryKey;
                let f = e.length;
                d = new Array(f);
                for (let g = 0; g < f; g++) {
                    d[g] = this.getItemProperty(b, e[g]);
                }
            }
            for (let h = 0; h < this.c1.count; h++) {
                if (c.h(this.c1._inner[h], d) == 0) {
                    return true;
                }
            }
            return false;
        }
        get_isSortingSupported() {
            if (this.externalDataSource != null && !this.cs) {
                this.cs = true;
                let a = this.externalDataSource.isSortingSupportedOverride;
                this.cs = false;
                return a;
            }
            return true;
        }
        get_isFilteringSupported() {
            if (this.externalDataSource != null && !this.cs) {
                this.cs = true;
                let a = this.externalDataSource.isFilteringSupportedOverride;
                this.cs = false;
                return a;
            }
            return true;
        }
        get_isGroupingSupported() {
            if (this.externalDataSource != null && !this.cs) {
                this.cs = true;
                let a = this.externalDataSource.isGroupingSupportedOverride;
                this.cs = false;
                return a;
            }
            return true;
        }
        getStickyRowPriority(a) {
            let b = this.getRowType(a);
            switch (b) {
                case 1: return 100 - this.getRowLevel(a);
                case 2: return 99 - this.getRowLevel(a);
                case 3:
                case 5: return 2;
                case 4: return 3;
            }
            return 1;
        }
        getStickyRowsInRange(a, b) {
            if (this.cp == null || ((this.groupDescriptions == null || this.groupDescriptions.k.count == 0) && (this.summaryDescriptions == null || this.summaryDescriptions.k.count == 0) && !this.cu())) {
                return null;
            }
            let c = null;
            let d = null;
            if (this.cp.a5.count == 1) {
                c = this.cp.a5._inner[0];
                d = this.cp.a5._inner[0];
            }
            else {
                c = this.cp.w(a);
                if (c != null) {
                    while (c.z != -1) {
                        c = this.cp.a5._inner[c.z];
                    }
                }
                d = this.cp.w(b);
                if (b >= this.cp.a6.count - this.cp.bk) {
                    d = this.cp.v();
                }
            }
            if (c == null || d == null) {
                return null;
            }
            if (c.ae == this.c9 && c.aa == this.db && c.af == this.dc && c.ad == this.da && c.ah == this.de && c.ag == this.dd && d.ae == this.c2 && d.aa == this.c4 && d.af == this.c5 && d.ad == this.c3 && d.ah == this.c7 && d.ag == this.c6 && this.cp.bk == this.c8) {
                return this.ce;
            }
            this.c9 = c.ae;
            this.c2 = d.ae;
            this.db = c.aa;
            this.c4 = d.aa;
            this.dc = c.af;
            this.c5 = d.af;
            this.da = c.ad;
            this.c3 = d.ad;
            this.de = c.ah;
            this.dd = c.ag;
            this.c7 = d.ah;
            this.c6 = d.ag;
            this.c8 = this.cp.bk;
            if (this.cp.a5.count == 1) {
                this.c2 = d.ad;
            }
            let e = 0;
            if (this.shouldEmitSectionHeaders && this.aj) {
                e = 1;
            }
            let f = this.cp.ba();
            let g = new List$1(Number_$type, 0);
            for (let h = c.ae; h <= d.ae; h++) {
                let i = this.cp.a5._inner[h];
                let j = this.cp.a5._inner[h].c.length;
                let k = this.cp.a5._inner[h].w();
                if (this.shouldEmitSectionHeaders && this.aj) {
                    for (let l = 0; l < j; l++) {
                        if (this.cp.a5._inner[h].a[l] != null) {
                            let m = i.af + i.b[l];
                            g.add(m);
                            if (this.summaryScope == 0 || this.summaryScope == 2) {
                                if (i.c[l] && this.includeSummaryRowsInSection && !this.isSectionSummaryRowsAtBottom) {
                                    for (let n = 0; n < f; n++) {
                                        g.add(m + 1 + n);
                                    }
                                }
                            }
                        }
                        if (!this.cp.a5._inner[h].c[l]) {
                            break;
                        }
                    }
                }
                if (this.cp.a5._inner[h].q) {
                    if (this.shouldEmitShiftedRows) {
                        for (let o = 0; o < this.cp.a5._inner[h].aa; o++) {
                            g.add(this.cp.a5._inner[h].af + this.cp.a5._inner[h].ah + o + k);
                        }
                    }
                }
                if (this.summaryScope == 0 || this.summaryScope == 2) {
                    if (this.includeSummaryRowsInSection && this.isSectionSummaryRowsAtBottom) {
                        for (let p = this.cp.a5._inner[h].ag - 1; p >= 0; p--) {
                            if (this.shouldEmitSectionFooters) {
                                g.add(this.cp.a5._inner[h].ad - k - p);
                            }
                            else {
                                g.add(this.cp.a5._inner[h].ad - p);
                            }
                        }
                    }
                }
                if (this.shouldEmitSectionFooters && this.aj) {
                    for (let q = j - 1; q >= 0; q--) {
                        if (!this.cp.a5._inner[h].c[q]) {
                            break;
                        }
                        g.add(this.cp.a5._inner[h].ad - q);
                    }
                }
            }
            for (let r = this.cp.a6.count - this.cp.bk; r < this.cp.a6.count; r++) {
                g.add(r);
            }
            this.ce = g.toArray();
            return this.ce;
        }
        isExclusivelySticky(a) {
            let b = this.getRowType(a);
            return b == 1 || b == 2 || b == 4 || (this.isSectionSummaryRowsAtBottom && b == 5);
        }
        getRowType(a) {
            if (a < 0) {
                return 0;
            }
            let b = this.getItemAtIndex(a);
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                let c = b.rowType;
                if (this.isSectionHeaderNormalRow && c == 1) {
                    return 0;
                }
                return c;
            }
            return 0;
        }
        setIsRowExpandedAtIndex(a, b) {
            if (this.isSectionCollapsable && this.cp != null && this.cp.a6.count > 0 && this.cp.a6.count > a) {
                this.cp.ca(a, b);
            }
        }
        getIsRowExpandedAtIndex(a) {
            if (this.cp != null && this.cp.a6.count > 0 && this.cp.a6.count > a) {
                return this.cp.ak(a);
            }
            return true;
        }
        getRowLevel(a) {
            if (a < 0) {
                return 0;
            }
            let b = this.getItemAtIndex(a);
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                return b.level;
            }
            if (this.sectionHeaderDisplayMode == 1) {
                return this.groupDescriptions.k.count;
            }
            else if (this.groupDescriptions.k.count > 0) {
                return 1;
            }
            return 0;
        }
        getRootSummaryRowCount() {
            if (this.cp != null) {
                return this.cp.bk;
            }
            return 0;
        }
        getRootSummaryResults() {
            if (this.cp != null) {
                return this.cp.i;
            }
            return null;
        }
        getSectionSummaryResults(a) {
            if (this.cp != null && this.cp.a5.count > 0 && a >= 0 && a < this.cp.a5.count) {
                return this.cp.a5._inner[a].j;
            }
            return null;
        }
        clone() {
            let a = new LocalDataSource();
            a.itemsSource = this.itemsSource;
            super.cloneProperties(a);
            return a;
        }
    }
    LocalDataSource.$t = /*@__PURE__*/ markType(LocalDataSource, 'LocalDataSource', BaseDataSource.$);
    return LocalDataSource;
})();
/**
 * @hidden
 */
export let LocalDataSourceViewUpdateNotifier = /*@__PURE__*/ (() => {
    class LocalDataSourceViewUpdateNotifier extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        notifyClearItems() {
            this.a.dk();
        }
        notifyInsertItem(a, b) {
            this.a.dl(a, b);
        }
        notifyRemoveItem(a, b) {
            this.a.dm(a, b);
        }
        notifySetItem(a, b, c) {
            this.a.dn(a, b, c);
        }
    }
    LocalDataSourceViewUpdateNotifier.$t = /*@__PURE__*/ markType(LocalDataSourceViewUpdateNotifier, 'LocalDataSourceViewUpdateNotifier', Base.$, [ISupportsDataChangeNotifications_$type]);
    return LocalDataSourceViewUpdateNotifier;
})();
/**
 * @hidden
 */
export let LocalDataSourceViewExpansionNotifier = /*@__PURE__*/ (() => {
    class LocalDataSourceViewExpansionNotifier extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        notifyRowExpansionChanged(a, b, c) {
            this.a.onRowExpansionChanged(a, b, c);
        }
    }
    LocalDataSourceViewExpansionNotifier.$t = /*@__PURE__*/ markType(LocalDataSourceViewExpansionNotifier, 'LocalDataSourceViewExpansionNotifier', Base.$, [ISupportsExpansionChangeNotifications_$type]);
    return LocalDataSourceViewExpansionNotifier;
})();
//# sourceMappingURL=LocalDataSource_combined.js.map
