import { Description } from "./Description";
import { ColumnDescription } from "./ColumnDescription";
import { SectionHeaderDescription } from "./SectionHeaderDescription";
import { SummaryRowRootDescription } from "./SummaryRowRootDescription";
import { SummaryRowSectionDescription } from "./SummaryRowSectionDescription";
import { RowSeparatorDescription } from "./RowSeparatorDescription";
import { HeaderSeparatorDescription } from "./HeaderSeparatorDescription";
import { ColumnResizingSeparatorDescription } from "./ColumnResizingSeparatorDescription";
import { ColumnMovingSeparatorDescription } from "./ColumnMovingSeparatorDescription";
import { PinnedAreaSeparatorDescription } from "./PinnedAreaSeparatorDescription";
import { GridAnimationSettingsDescription } from "./GridAnimationSettingsDescription";
import { GridCellPositionDescription } from "./GridCellPositionDescription";
import { Type } from "./type";
/**
 * @hidden
 */
export declare class DataGridDescription extends Description {
    static $t: Type;
    private g;
    columns: ColumnDescription[];
    private dk;
    width: string;
    private cs;
    height: string;
    private bs;
    background: string;
    protected get_type(): string;
    readonly type: string;
    constructor();
    private cc;
    columnResizingMode: string;
    private b8;
    columnMovingMode: string;
    private ab;
    sectionHeader: SectionHeaderDescription;
    private ad;
    summaryRowRoot: SummaryRowRootDescription;
    private af;
    summaryRowSection: SummaryRowSectionDescription;
    private z;
    rowSeparator: RowSeparatorDescription;
    private v;
    headerSeparator: HeaderSeparatorDescription;
    private p;
    columnResizingSeparator: ColumnResizingSeparatorDescription;
    private n;
    columnMovingSeparator: ColumnMovingSeparatorDescription;
    private x;
    pinnedAreaSeparator: PinnedAreaSeparatorDescription;
    private h;
    dataSourceDesiredProperties: string[];
    private bh;
    rowHeight: number;
    private a3;
    defaultColumnMinWidth: number;
    private be;
    headerHeight: number;
    private cg;
    dataSourceRef: string;
    private cn;
    headerClickAction: string;
    private ah;
    autoGenerateColumns: boolean;
    private bi;
    rowSeparatorHeight: number;
    private an;
    isPlaceholderRenderingEnabled: boolean;
    private b3;
    columnAddingAnimationMode: string;
    private ca;
    columnPropertyUpdatingAnimationMode: string;
    private bv;
    cellDataLoadedAnimationMode: string;
    private cv;
    rowSelectionAnimationMode: string;
    private b1;
    cellSelectionAnimationMode: string;
    private r;
    animationSettings: GridAnimationSettingsDescription;
    private cb;
    columnResizingAnimationMode: string;
    private cf;
    columnShowingAnimationMode: string;
    private b7;
    columnMovingAnimationMode: string;
    private b6;
    columnHidingAnimationMode: string;
    private b4;
    columnExchangingAnimationMode: string;
    private c8;
    selectionMode: string;
    private bq;
    activationMode: string;
    private c7;
    selectionBehavior: string;
    private ai;
    isFilterUIEnabled: boolean;
    private al;
    isGroupRowSticky: boolean;
    private am;
    isHeaderSeparatorVisible: boolean;
    private b0;
    cellSelectedBackground: string;
    private c1;
    sectionHeaderSelectedBackground: string;
    private db;
    summaryRootBackground: string;
    private dg;
    summarySectionBackground: string;
    private a4;
    pinnedRowOpacity: number;
    private da;
    stickyRowBackground: string;
    private cu;
    pinnedRowBackground: string;
    private ct;
    lastStickyRowBackground: string;
    private t;
    activeCell: GridCellPositionDescription;
    private bt;
    cellBackground: string;
    private b2;
    cellTextColor: string;
    private cp;
    headerSortIndicatorColor: string;
    private cq;
    headerSortIndicatorStyle: string;
    private _cellFontFamily;
    cellFontFamily: string;
    private _cellFontSize;
    cellFontSize: number;
    private _cellFontStyle;
    cellFontStyle: string;
    private _cellFontWeight;
    cellFontWeight: string;
    private c0;
    sectionHeaderBackground: string;
    private c2;
    sectionHeaderTextColor: string;
    private _sectionHeaderFontFamily;
    sectionHeaderFontFamily: string;
    private _sectionHeaderFontSize;
    sectionHeaderFontSize: number;
    private _sectionHeaderFontStyle;
    sectionHeaderFontStyle: string;
    private _sectionHeaderFontWeight;
    sectionHeaderFontWeight: string;
    private de;
    summaryRootTextColor: string;
    private dj;
    summarySectionTextColor: string;
    private dc;
    summaryRootNameTextColor: string;
    private dh;
    summarySectionNameTextColor: string;
    private dd;
    summaryRootSelectedBackground: string;
    private di;
    summarySectionSelectedBackground: string;
    private _summaryFontFamily;
    summaryFontFamily: string;
    private _summaryFontSize;
    summaryFontSize: number;
    private _summaryFontStyle;
    summaryFontStyle: string;
    private _summaryFontWeight;
    summaryFontWeight: string;
    private _summarySectionFontFamily;
    summarySectionFontFamily: string;
    private _summarySectionFontSize;
    summarySectionFontSize: number;
    private _summarySectionFontStyle;
    summarySectionFontStyle: string;
    private _summarySectionFontWeight;
    summarySectionFontWeight: string;
    private bg;
    pinnedAreaSeparatorWidth: number;
    private bf;
    headerSeparatorWidth: number;
    private co;
    headerSeparatorBackground: string;
    private cm;
    headerBackground: string;
    private cr;
    headerTextColor: string;
    private _headerFontFamily;
    headerFontFamily: string;
    private _headerFontSize;
    headerFontSize: number;
    private _headerFontStyle;
    headerFontStyle: string;
    private _headerFontWeight;
    headerFontWeight: string;
    private cw;
    rowSeparatorBackground: string;
    private cz;
    rowSeparatorStickyRowBackground: string;
    private cx;
    rowSeparatorLastStickyRowBackground: string;
    private cy;
    rowSeparatorPinnedRowBackground: string;
    private bd;
    columnResizingSeparatorWidth: number;
    private bc;
    columnMovingSeparatorWidth: number;
    private cd;
    columnResizingSeparatorBackground: string;
    private b9;
    columnMovingSeparatorBackground: string;
    private ar;
    shiftSectionContent: boolean;
    private df;
    summaryScope: string;
    private aj;
    isGroupCollapsable: boolean;
    private ck;
    groupHeaderDisplayMode: string;
    private ak;
    isGroupExpandedDefault: boolean;
    private cl;
    groupSummaryDisplayMode: string;
    private i;
    primaryKey: string[];
    private f;
    actualPrimaryKey: string[];
    private aq;
    reactsToSortChanges: boolean;
    private ap;
    reactsToGroupChanges: boolean;
    private ao;
    reactsToFilterChanges: boolean;
    private ci;
    filterExpressionsChangingRef: string;
    private ch;
    filterExpressionsChangedRef: string;
    private by;
    cellPreviewPointerDownRef: string;
    private bz;
    cellPreviewPointerUpRef: string;
    private bw;
    cellPointerDownRef: string;
    private bx;
    cellPointerUpRef: string;
    private bu;
    cellClickedRef: string;
    private c9;
    sortDescriptionsChangedRef: string;
    private cj;
    groupDescriptionsChangedRef: string;
    private b5;
    columnHiddenChangedRef: string;
    private ce;
    columnsAutoGeneratedRef: string;
    private c5;
    selectedItemsChangedRef: string;
    private c6;
    selectedKeysChangedRef: string;
    private c4;
    selectedCellsChangedRef: string;
    private br;
    activeCellChangedRef: string;
    private c3;
    selectedCellRangesChangedRef: string;
}
